﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Graphics;
using Com.Syncfusion.Charts.Enums;

namespace CustomDoughnutChart
{
    [Activity(Label = "CustomDoughnutChart", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        LinearLayout linearLayout;

        TextView textView;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            linearLayout = new LinearLayout(this);
            linearLayout.Orientation = Android.Widget.Orientation.Vertical;

            SfChart chart = new SfChart(this);
            chart.SetBackgroundColor(Color.White);

            chart.PrimaryAxis = new CategoryAxis();
            chart.SecondaryAxis = new NumericalAxis();

            textView = new TextView(this);
            textView.Text = "No Data";

            ObservableArrayList dataPoints = new ObservableArrayList();

            ColumnSeries columnSeries = new ColumnSeries();
            columnSeries.DataSource = dataPoints;
            chart.Series.Add(columnSeries);

            chart.Behaviors.Add(new CustomBehavior(chart, textView));

            linearLayout.AddView(chart);

            SetContentView(linearLayout);
        }
    }

    public class CustomBehavior : ChartBehavior
    {
        private SfChart chart;

        private TextView textView;

        private Paint paint;

        Rect rect;
        public CustomBehavior(SfChart chart, TextView textView)
        {
            this.chart = chart;

            this.textView = textView;

            paint = new Paint();

            rect = new Rect();
        }

        protected override void OnDraw(Canvas p0)
        {
            for (int i = 0; i < chart.Series.Size(); i++)
            {
                for (int j = 0; j <= ((chart.Series.Get(i) as ChartSeries).DataSource as ObservableArrayList).Size(); j++)
                {
                    if (((chart.Series.Get(i) as ChartSeries).DataSource as ObservableArrayList).Size() == 0)
                    {
                        paint.Color = Android.Graphics.Color.Red;
                        paint.SetStyle(Paint.Style.Fill);
                        paint.AntiAlias = true;
                        paint.TextSize = 25;
                        paint.GetTextBounds(textView.Text, 0, textView.Text.Length, rect);
                        p0.DrawText(this.textView.Text, chart.SeriesClipRect.CenterX() - rect.Width(), chart.SeriesClipRect.CenterY(), paint);
                        base.OnDraw(p0);
                    }
                }
            }
        }
    }
}


